import os
import psutil

from datetime import datetime


def get_mu7d():
    psss = []
    u7d_parent = False

    if found := [ps for ps in psutil.process_iter() if os.path.basename(ps.name()) in SET_0]:
        u7d_parent = found[0]
        psss = [u7d_parent] + u7d_parent.children(recursive=True)[1:]

    else:
        for ps in [ps for ps in psutil.process_iter() if os.path.basename(ps.name()) in SET_2 | SET_4]:
            try:
                name = os.path.basename(ps.name())
                if name in SET_2:
                    cmd = os.path.basename(ps.cmdline()[1])
                    if cmd in SET_1:
                        u7d_parent = ps
                        psss = [u7d_parent] + u7d_parent.children(recursive=True)
                        break
                    if cmd in SET_3:
                        psss.append(ps)
                elif name in SET_4:
                    psss.append(ps)
            except (psutil.AccessDenied, psutil.NoSuchProcess):
                pass

    print(f"{datetime.now()}\n")

    if u7d_parent:
        print(f"\bU7D_PARENT = {u7d_parent}\n")

    for ps in psss:
        print(f"[{ps.pid:5}] [{' '.join(ps.cmdline())}]")

    if not psss:
        print("Nothing found")

    return psss


if __name__ == "__main__":
    SET_0 = {"mu7d.exe"}
    SET_1 = {"mu7d.py"}
    SET_2 = {"python.exe"}
    SET_3 = {"movistar_epg.py", "movistar_tvg.py", "movistar_u7d.py", "movistar_vod.py"}
    SET_4 = {
        "comskip.exe",
        "ffmpeg.exe",
        "ffprobe.exe",
        "movistar_epg.exe",
        "movistar_tvg.exe",
        "movistar_u7d.exe",
        "movistar_vod.exe",
    }

    get_mu7d()
